import es
import popuplib
import base64
import cPickle
import os
from configobj import ConfigObj
#This Addon is a Python recode from Daves Addon rules!


addonpath = es.getAddonPath("rules").replace("\\", "/")
config = ConfigObj("%s/ruleconfig.ini" % addonpath)

#NO LONGER ANY EDIT IN THIS FILE REQUIRED!
#CONFIGFILE: ../addons/eventscripts/rules/rulesconfig.ini

resend_popup_command = config["general"]["popupcommand"]
announce = int(config["general"]["announce_rounds"])
adminlist = config["general"]["adminlist"]
popup_type = int(config["general"]["popup_type"])
show_to_admins = int(config["general"]["show_rules_to_admins"])

server_rules = config["rules"]




info = es.AddonInfo()
info.basename = "rules"
info.name = "Rules"
info.author = "Brainsucker"
info.version = "1.1.1 Beta"

#Might be slower on loading but much faster when saving. So we avoid laggs and can save 'small' dictionarys while the round is running.
adminnames = {}
if os.path.isdir("%s/admindata" % addonpath):
	for a in filter(lambda temp: temp.endswith(".db"), os.listdir("%s/admindata" % addonpath)):
		adminnames[a.replace("-", ":").rsplit(".")[0]] = cPickle.load(open("%s/admindata/%s.db" % (addonpath, a.replace("-", ":")), "wb"))
	for b in filter(lambda temp: not temp in adminlist, adminnames.keys()):
		del adminnames[b]

		
roundcounter = 0


def getAdminNameList():
	l = []
	for x in adminnames:
		l.append(adminnames[x]["lastname"])
	return l


def load():
	if info.author == base64.decodestring("QnJhaW5zdWNrZXI=\n"):
		es.ServerVar(info.name, info.version).makepublic()
		spopup = popuplib.create("startpopup")
		spopup.addline("Welcome to our Server\n-Addon by Brainsucker-\nChoose an option:")
		x = 0
		if popup_type in [1,2]:
			spopup.addline("->1. Show me the Rules")
		if popup_type in [1,3]:
			spopup.addline("->2. Show me the Admins")
		spopup.menuselect = spopup_select
			
			
		rpopup = popuplib.easymenu("rulespopup", None, rpopup_select)
		rpopup.settitle("Our Serverrules:")
		for rule in server_rules:
			rpopup.addoption(rule, server_rules[rule]["name_of_rule"])
		
def player_activate(ev):
	steamid = ev["es_steamid"]
	userid = ev["userid"]
	if steamid in adminlist:
		if show_to_admins:
			popuplib.send("startpopup", userid)
		if not adminnames.has_key(steamid):
			adminnames[steamid] = {}
		adminnames[steamid]["lastname"] = ev["es_username"]
		if not os.path.isdir("%s/admindata" % addonpath):
			os.mkdir("%s/admindata" % addonpath)
		f = open("%s/admindata/%s.db" % (addonpath, steamid.replace(":", "-")), "wb")
		cPickle.dump(adminnames[steamid], f)
	else:
		popuplib.send("startpopup", userid)
		
def player_say(ev):
	if ev["text"] == resend_popup_command:
		popuplib.send("startpopup", ev["userid"])
		
def spopup_select(userid, choice, popupid):
	if choice == 1:
		popuplib.send("rulespopup", userid)
	if choice == 2:
		al = getAdminNameList()
		popuplib.quicksend(0, userid, "Our Admins:\n%s" % ("\n".join(al) if len(al) > 0 else "No Admins have been recorded yet."))
		
def rpopup_select(userid, choice, popupid):
	popuplib.quicksend(0, userid, "Rule specified description:\n%s\n\nPunish when you break the rule: %s\n---\n->0. Back" % ((server_rules[choice]["description_of_rule"] if server_rules[choice].has_key("description_of_rule") else "No description has been added"), (server_rules[choice]["punish_when_break_rule"] if server_rules[choice].has_key("punish_when_break_rule") else "No punishment has been added")), lambda a,b,c: popuplib.send("rulespopup", a))
		
		
def round_start(ev):
	global roundcounter
	if announce:
		if roundcounter >= announce:
			es.msg("#multi", "#defaultType #green%s #defaultin the Chat to view our Rules or Admins." % resend_popup_command)
			roundcounter = 0
	roundcounter += 1
		
def unload():
	popuplib.delete("startpopup")
	popuplib.delete("rulespopup")